package eu.beesoft.gantt.demo;

import eu.beesoft.gantt.Dependency;
import eu.beesoft.gantt.DependencyType;
import eu.beesoft.gantt.TimelineObject;

public class TaskDependency implements Dependency {

	private TimelineObject successor;

	private TimelineObject predecessor;

	private long delay;

	private DependencyType type;



	public TaskDependency () {
		type = DependencyType.FINISH_TO_START;
	}



	public TaskDependency (Task task, Task dependsOn) {
		setSuccessor (task);
		setPredecessor (dependsOn);
	}



	/**
	 * @return the object
	 */
	public TimelineObject getSuccessor () {
		return successor;
	}



	/**
	 * @param object
	 *            the object to set
	 */
	public void setSuccessor (TimelineObject object) {
		this.successor = object;
		if (object instanceof Task) {
			((Task) object).addDependency (this);
		}
	}



	/**
	 * @return the dependsOn
	 */
	public TimelineObject getPredecessor () {
		return predecessor;
	}



	/**
	 * @param dependsOn
	 *            the dependsOn to set
	 */
	public void setPredecessor (TimelineObject dependsOn) {
		this.predecessor = dependsOn;
		if (dependsOn instanceof Task) {
			((Task) dependsOn).addDependency (this);
		}
	}



	/**
	 * @return the delay
	 */
	public long getDelay () {
		return delay;
	}



	/**
	 * @param delay
	 *            the delay to set
	 */
	public void setDelay (long delay) {
		this.delay = delay;
	}



	/**
	 * @return the type
	 */
	public DependencyType getType () {
		return type;
	}



	/**
	 * @param type
	 *            the type to set
	 */
	public void setType (DependencyType type) {
		if (type == null) {
			type = DependencyType.FINISH_TO_START;
		}
		this.type = type;
	}

}
